package jp.programmers.pizza.actions;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.programmers.pizza.dao.ItemDAO;
import jp.programmers.pizza.dao.DAOFactory;
import jp.programmers.pizza.forms.ItemForm;
import jp.programmers.pizza.model.Item;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * ieiXsANVłB
 */
public class ItemAction extends Action {

    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
        throws Exception {

        ItemDAO itemDAO = (ItemDAO)DAOFactory.get("itemDAO");

        ItemForm itemForm = (ItemForm)form;
        if (!itemForm.isEmpty()) {
            Item item = new Item();
            item.setId(itemForm.getId());
            item.setName(itemForm.getName());
            item.setPrice(itemForm.getPrice());
            if (itemForm.getDelete()) {
                itemDAO.delete(item);
            } else {
                itemDAO.saveOrUpdate(item);
            }
        }
        request.removeAttribute("itemForm");

        List items = itemDAO.findAll();
        request.setAttribute("items", items);

        return mapping.findForward("success");
    }
}
