package jp.programmers.pizza.dao.hibernate;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import jp.programmers.pizza.model.Order;
import jp.programmers.pizza.dao.OrderDAO;
import net.sf.hibernate.Criteria;
import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.expression.Expression;
import org.springframework.orm.hibernate.HibernateCallback;
import org.springframework.orm.hibernate.support.HibernateDaoSupport;

/**
 * I[_DAONX
 */
public class OrderDAOImpl
    extends HibernateDaoSupport implements OrderDAO {

    /** I[_ۑ܂B */
    public void save(Order order) {
        getHibernateTemplate().save(order);
    }

    /** I[_܂B */
    public List find(final String phone,
                     final Date from,
                     final Date to) {
		List result =
            getHibernateTemplate().executeFind(new HibernateCallback() {
                public Object doInHibernate(Session session)
                    throws HibernateException {
                    Criteria criteria = session.createCriteria(Order.class);
                    if (from != null) {
                        criteria.add(Expression.ge("orderDate", from));
                    }
                    if (to != null) {
                        criteria.add(Expression.lt("orderDate", to));
                    }
                    if (phone != null) {
                        criteria.createCriteria("customer").
                            add(Expression.eq("phone", phone));
                    }
                    return criteria.list();
                }
            });
        return result;
    }

    /** I[_ڍׂ擾܂B */
    public Order getOrderWithDetails(Serializable id) {
        Order result = null;
        List list = 
            getHibernateTemplate().find(
                "from Order o left join fetch o.details where o.id = ?",
                id, Hibernate.INTEGER);
        if (!list.isEmpty()) {
            result = (Order)list.get(0);
        }
        return result;
    }
}
