package jp.programmers.pizza.model;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

/**
 * I[_NX
 * @hibernate.class table="ORDER_DATA"
 * @hibernate.cache usage="read-only"
 */
public class Order implements java.io.Serializable {

    /** ID */
    private Integer id = null;
    /**  */
    private Customer customer = null;
    /** I[_ */
    private Date orderDate = null;
    /** I[_ڍ */
    private Set details = null;
    /** I[_̑ΏۂƂȂ鏤i */
    private List items = null;

    /**
     * @hibernate.id column="ID" generator-class="identity"
     */
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * @hibernate.many-to-one
     *   column="CUSTOMER_ID"
     *   class="jp.programmers.pizza.model.Customer"
     *   not-null="true"
     */
    public Customer getCustomer() {
        return customer;
    }

    public void setCustomer(Customer customer) {
        this.customer = customer;
    }

    /**
     * @hibernate.property
     *   column="ORDER_DATE"
     *   not-null="true"
     */
    public Date getOrderDate() {
        return orderDate;
    }

    public void setOrderDate(Date orderDate) {
        this.orderDate = orderDate;
    }

    /**
     * @hibernate.set
     *   cascade="all"
     *   lazy="true"
     * @hibernate.collection-key
     *   column="ORDER_ID"
     * @hibernate.collection-one-to-many
     *   class="jp.programmers.pizza.model.OrderDetail"
     */
    public Set getDetails() {
        if (details == null) {
            details = new HashSet();
        }
        return details;
    }

    public void setDetails(Set details) {
        this.details = details;
    }

    public void addDetail(OrderDetail detail) {
        Set details = getDetails();
        details.add(detail);
        detail.setOrder(this);
    }

    public int getTotalPrice() {
        int result = 0;
        for (Iterator it = getDetails().iterator(); it.hasNext();) {
            OrderDetail od = (OrderDetail)it.next();
            result += od.getSubtotalPrice();
        }
        return result;
    }

    public void setItems(List items) {
        this.items = items;
    }

    public List getItems() {
        return items;
    }
}
